Index: src/lemon/preflow.h
===================================================================
--- src/lemon/preflow.h	(revision 977)
+++ src/lemon/preflow.h	(revision 986)
@@ -306,5 +306,5 @@
 	for(InEdgeIt e(*g,v); e!=INVALID; ++e) {
 	  if ( (*capacity)[e] <= (*flow)[e] ) continue;
-	  Node u=g->tail(e);
+	  Node u=g->source(e);
 	  if ( level[u] >= n ) {
 	    bfs_queue.push(u);
@@ -319,5 +319,5 @@
 	for(OutEdgeIt e(*g,v); e!=INVALID; ++e) {
 	  if ( 0 >= (*flow)[e] ) continue;
-	  Node u=g->head(e);
+	  Node u=g->target(e);
 	  if ( level[u] >= n ) {
 	    bfs_queue.push(u);
@@ -411,5 +411,5 @@
 	
 	for(OutEdgeIt e(*g,w) ; e!=INVALID; ++e) {
-	  Node v=g->head(e);
+	  Node v=g->target(e);
 	  if (!M[v] && (*flow)[e] < (*capacity)[e] ) {
 	    queue.push(v);
@@ -419,5 +419,5 @@
 	
 	for(InEdgeIt e(*g,w) ; e!=INVALID; ++e) {
-	  Node v=g->tail(e);
+	  Node v=g->source(e);
 	  if (!M[v] && (*flow)[e] > 0 ) {
 	    queue.push(v);
@@ -449,5 +449,5 @@
 
 	for(InEdgeIt e(*g,w) ; e!=INVALID; ++e) {
-	  Node v=g->tail(e);
+	  Node v=g->source(e);
 	  if (M[v] && (*flow)[e] < (*capacity)[e] ) {
 	    queue.push(v);
@@ -457,5 +457,5 @@
 
 	for(OutEdgeIt e(*g,w) ; e!=INVALID; ++e) {
-	  Node v=g->head(e);
+	  Node v=g->target(e);
 	  if (M[v] && (*flow)[e] > 0 ) {
 	    queue.push(v);
@@ -516,5 +516,5 @@
       for(OutEdgeIt e(*g,w) ; e!=INVALID; ++e) {
 	if ( (*flow)[e] >= (*capacity)[e] ) continue;
-	Node v=g->head(e);
+	Node v=g->target(e);
 
 	if( lev > level[v] ) { //Push is allowed now
@@ -548,5 +548,5 @@
 	  
 	  if( (*flow)[e] <= 0 ) continue;
-	  Node v=g->tail(e);
+	  Node v=g->source(e);
 
 	  if( lev > level[v] ) { //Push is allowed now
@@ -603,5 +603,5 @@
 	  for(InEdgeIt e(*g,v) ; e!=INVALID; ++e) {
 	    if ( (*capacity)[e] <= (*flow)[e] ) continue;
-	    Node w=g->tail(e);
+	    Node w=g->source(e);
 	    if ( level[w] == n && w != s ) {
 	      bfs_queue.push(w);
@@ -616,5 +616,5 @@
 	  for(OutEdgeIt e(*g,v) ; e!=INVALID; ++e) {
 	    if ( 0 >= (*flow)[e] ) continue;
-	    Node w=g->head(e);
+	    Node w=g->target(e);
 	    if ( level[w] == n && w != s ) {
 	      bfs_queue.push(w);
@@ -647,5 +647,5 @@
 	  
 	  for(InEdgeIt e(*g,v) ; e!=INVALID; ++e) {
-	    Node w=g->tail(e);
+	    Node w=g->source(e);
 	    if ( level[w] == n && w != s ) {
 	      bfs_queue.push(w);
@@ -663,5 +663,5 @@
 	  Num c=(*capacity)[e];
 	  if ( c <= 0 ) continue;
-	  Node w=g->head(e);
+	  Node w=g->target(e);
 	  if ( level[w] < n ) {
 	    if ( excess[w] <= 0 && w!=t ) { //putting into the stack
@@ -688,5 +688,5 @@
 	  Num rem=(*capacity)[e]-(*flow)[e];
 	  if ( rem <= 0 ) continue;
-	  Node w=g->head(e);
+	  Node w=g->target(e);
 	  if ( level[w] < n ) {
 	    if ( excess[w] <= 0 && w!=t ) { //putting into the stack
@@ -701,5 +701,5 @@
 	for(InEdgeIt e(*g,s); e!=INVALID; ++e) {
 	  if ( (*flow)[e] <= 0 ) continue;
-	  Node w=g->tail(e);
+	  Node w=g->source(e);
 	  if ( level[w] < n ) {
 	    if ( excess[w] <= 0 && w!=t ) {
@@ -718,5 +718,5 @@
 	  Num rem=(*capacity)[e]-(*flow)[e];
 	  if ( rem <= 0 ) continue;
-	  Node w=g->head(e);
+	  Node w=g->target(e);
 	  if ( level[w] < n ) flow->set(e, (*capacity)[e]);
 	}
@@ -724,5 +724,5 @@
 	for(InEdgeIt e(*g,s) ; e!=INVALID; ++e) {
 	  if ( (*flow)[e] <= 0 ) continue;
-	  Node w=g->tail(e);
+	  Node w=g->source(e);
 	  if ( level[w] < n ) flow->set(e, 0);
 	}
Index: src/lemon/smart_graph.h
===================================================================
--- src/lemon/smart_graph.h	(revision 980)
+++ src/lemon/smart_graph.h	(revision 986)
@@ -56,5 +56,5 @@
     struct EdgeT 
     {
-      int head, tail, next_in, next_out;      
+      int target, source, next_in, next_out;      
       //FIXME: is this necessary?
       EdgeT() : next_in(-1), next_out(-1) {}  
@@ -98,6 +98,6 @@
     int maxId(Edge = INVALID) const { return edges.size()-1; }
 
-    Node tail(Edge e) const { return edges[e.n].tail; }
-    Node head(Edge e) const { return edges[e.n].head; }
+    Node source(Edge e) const { return edges[e.n].source; }
+    Node target(Edge e) const { return edges[e.n].target; }
 
     /// Node ID.
@@ -128,5 +128,5 @@
     Edge addEdge(Node u, Node v) {
       Edge e; e.n=edges.size(); edges.push_back(EdgeT()); //FIXME: Hmmm...
-      edges[e.n].tail=u.n; edges[e.n].head=v.n;
+      edges[e.n].source=u.n; edges[e.n].target=v.n;
       edges[e.n].next_out=nodes[u.n].first_out;
       edges[e.n].next_in=nodes[v.n].first_in;
@@ -212,5 +212,5 @@
     {
       int e = (prev.n==-1)? nodes[u.n].first_out : edges[prev.n].next_out;
-      while(e!=-1 && edges[e].tail!=v.n) e = edges[e].next_out;
+      while(e!=-1 && edges[e].source!=v.n) e = edges[e].next_out;
       prev.n=e;
       return prev;
@@ -308,6 +308,6 @@
       while(s.edge_num>edges.size()) {
 	edge_observers.erase(Edge(edges.size()-1));
-	nodes[edges.back().head].first_in=edges.back().next_in;
-	nodes[edges.back().tail].first_out=edges.back().next_out;
+	nodes[edges.back().target].first_in=edges.back().next_in;
+	nodes[edges.back().source].first_out=edges.back().next_out;
 	edges.pop_back();
       }
Index: src/lemon/suurballe.h
===================================================================
--- src/lemon/suurballe.h	(revision 968)
+++ src/lemon/suurballe.h	(revision 986)
@@ -134,5 +134,5 @@
 	    ++e;
 	  }
-	  n = G.head(e);
+	  n = G.target(e);
 	  paths[j].push_back(e);
 	  //total_length += length[e];
Index: src/lemon/undir_graph_extender.h
===================================================================
--- src/lemon/undir_graph_extender.h	(revision 981)
+++ src/lemon/undir_graph_extender.h	(revision 986)
@@ -71,21 +71,21 @@
     }
 
-    /// Tail of the given Edge.
-    Node tail(const Edge &e) const {
-      return e.forward ? Parent::tail(e) : Parent::head(e);
+    /// Source of the given Edge.
+    Node source(const Edge &e) const {
+      return e.forward ? Parent::source(e) : Parent::target(e);
     }
 
-    /// \todo Shouldn't the "tail" of an undirected edge be called "aNode"
+    /// \todo Shouldn't the "source" of an undirected edge be called "aNode"
     /// or something???
-    using Parent::tail;
+    using Parent::source;
 
-    /// Head of the given Edge.
-    Node head(const Edge &e) const {
-      return e.forward ? Parent::head(e) : Parent::tail(e);
+    /// Target of the given Edge.
+    Node target(const Edge &e) const {
+      return e.forward ? Parent::target(e) : Parent::source(e);
     }
 
-    /// \todo Shouldn't the "head" of an undirected edge be called "bNode"
+    /// \todo Shouldn't the "target" of an undirected edge be called "bNode"
     /// or something???
-    using Parent::head;
+    using Parent::target;
 
     /// Returns whether the given directed edge is same orientation as the
@@ -97,8 +97,8 @@
 
     Node oppsiteNode(const Node &n, const Edge &e) const {
-      if( n == Parent::tail(e))
-	return Parent::head(e);
-      else if( n == Parent::head(e))
-	return Parent::tail(e);
+      if( n == Parent::source(e))
+	return Parent::target(e);
+      else if( n == Parent::target(e))
+	return Parent::source(e);
       else
 	return INVALID;
@@ -148,5 +148,5 @@
 	Parent::nextOut(e);
 	if( UndirEdge(e) == INVALID ) {
-	  Parent::firstIn(e, Parent::tail(e));
+	  Parent::firstIn(e, Parent::source(e));
 	  e.forward = false;
 	}
@@ -160,5 +160,5 @@
 	Parent::nextIn(e);
 	if( UndirEdge(e) == INVALID ) {
-	  Parent::firstOut(e, Parent::head(e));
+	  Parent::firstOut(e, Parent::target(e));
 	  e.forward = false;
 	}
Index: src/test/bfs_test.cc
===================================================================
--- src/test/bfs_test.cc	(revision 959)
+++ src/test/bfs_test.cc	(revision 986)
@@ -84,6 +84,6 @@
 
   for(EdgeIt e(G); e==INVALID; ++e) {
-    Node u=G.tail(e);
-    Node v=G.head(e);
+    Node u=G.source(e);
+    Node v=G.target(e);
     check( !bfs_test.reached(u) ||
 	   (bfs_test.dist(v) > bfs_test.dist(u)+1),
@@ -95,5 +95,5 @@
     if ( bfs_test.pred(v)!=INVALID ) {
       Edge e=bfs_test.pred(v);
-      Node u=G.tail(e);
+      Node u=G.source(e);
       check(u==bfs_test.predNode(v),"Wrong tree.");
       check(bfs_test.dist(v) - bfs_test.dist(u) == 1,
Index: src/test/dfs_test.cc
===================================================================
--- src/test/dfs_test.cc	(revision 959)
+++ src/test/dfs_test.cc	(revision 986)
@@ -84,5 +84,5 @@
     if ( dfs_test.pred(v)!=INVALID ) {
       Edge e=dfs_test.pred(v);
-      Node u=G.tail(e);
+      Node u=G.source(e);
       check(u==dfs_test.predNode(v),"Wrong tree.");
       check(dfs_test.dist(v) - dfs_test.dist(u) == 1,
Index: src/test/dijkstra_heap_test.cc
===================================================================
--- src/test/dijkstra_heap_test.cc	(revision 921)
+++ src/test/dijkstra_heap_test.cc	(revision 986)
@@ -74,9 +74,9 @@
   EdgeIt e;
   for(G.first(e); e!=INVALID; ++e) {
-    Node u=G.tail(e);
-    Node v=G.head(e);
+    Node u=G.source(e);
+    Node v=G.target(e);
     if ( dijkstra_test.dist(v) - dijkstra_test.dist(u) > cap[e] )
       if ( dijkstra_test.reached(u) ) {
-	std::cout<<"Error! dist(head)-dist(tail)- edge_length= " 
+	std::cout<<"Error! dist(target)-dist(source)- edge_length= " 
 		 <<dijkstra_test.dist(v) - dijkstra_test.dist(u) 
 	  - cap[e]<<std::endl;
@@ -89,5 +89,5 @@
     if ( dijkstra_test.reached(v) ) {
       Edge e=dijkstra_test.pred(v);
-      Node u=G.tail(e);
+      Node u=G.source(e);
       if ( dijkstra_test.dist(v) - dijkstra_test.dist(u) != cap[e] ) {
 	std::cout<<"Error in a shortest path tree edge! Difference: " 
@@ -123,9 +123,9 @@
 
   for(G.first(e); e!=INVALID; ++e) {
-    Node u=G.tail(e);
-    Node v=G.head(e);
+    Node u=G.source(e);
+    Node v=G.target(e);
     if ( dijkstra_test2.dist(v) - dijkstra_test2.dist(u) > cap[e] )
       if ( dijkstra_test2.reached(u) ) {
-	std::cout<<"Error! dist(head)-dist(tail)- edge_length= " 
+	std::cout<<"Error! dist(target)-dist(source)- edge_length= " 
 		 <<dijkstra_test2.dist(v) - dijkstra_test2.dist(u) 
 	  - cap[e]<<std::endl;
@@ -137,5 +137,5 @@
     if ( dijkstra_test2.reached(v) ) {
       Edge e=dijkstra_test2.pred(v);
-      Node u=G.tail(e);
+      Node u=G.source(e);
       if ( dijkstra_test2.dist(v) - dijkstra_test2.dist(u) != cap[e] ) {
 	std::cout<<"Error in a shortest path tree edge! Difference: " 
Index: src/test/dijkstra_test.cc
===================================================================
--- src/test/dijkstra_test.cc	(revision 959)
+++ src/test/dijkstra_test.cc	(revision 986)
@@ -94,9 +94,9 @@
 
   for(EdgeIt e(G); e!=INVALID; ++e) {
-    Node u=G.tail(e);
-    Node v=G.head(e);
+    Node u=G.source(e);
+    Node v=G.target(e);
     check( !dijkstra_test.reached(u) ||
 	   (dijkstra_test.dist(v) - dijkstra_test.dist(u) <= cap[e]),
-	   "dist(head)-dist(tail)- edge_length= " 
+	   "dist(target)-dist(source)- edge_length= " 
 	   << dijkstra_test.dist(v) - dijkstra_test.dist(u) 
 	   - cap[e]);
@@ -108,5 +108,5 @@
     if ( dijkstra_test.pred(v)!=INVALID ) {
       Edge e=dijkstra_test.pred(v);
-      Node u=G.tail(e);
+      Node u=G.source(e);
       check(u==dijkstra_test.predNode(v),"Wrong tree.");
       check(dijkstra_test.dist(v) - dijkstra_test.dist(u) == cap[e],
Index: src/test/graph_factory_test.cc
===================================================================
--- src/test/graph_factory_test.cc	(revision 959)
+++ src/test/graph_factory_test.cc	(revision 986)
@@ -29,5 +29,5 @@
 This test makes consistency checks of list graph structures.
 
-G.addNode(), G.addEdge(), G.tail(), G.head()
+G.addNode(), G.addEdge(), G.source(), G.target()
 
 \todo Checks for empty graphs and isolated points.
@@ -49,5 +49,5 @@
 
   for(typename std::vector<Edge>::iterator p=ee.begin();p!=ee.end();p++)
-    G.addEdge(G.head(*p),G.tail(*p));
+    G.addEdge(G.target(*p),G.source(*p));
 }
 
Index: src/test/graph_test.h
===================================================================
--- src/test/graph_test.h	(revision 946)
+++ src/test/graph_test.h	(revision 986)
@@ -54,5 +54,5 @@
     for(int i=0;i<nn;i++) {
       check(e!=INVALID,"Wrong OutEdge list linking.");
-      check(n==G.tail(e), "Wrong OutEdge list linking.");
+      check(n==G.source(e), "Wrong OutEdge list linking.");
       ++e;
     }
@@ -66,5 +66,5 @@
     for(int i=0;i<nn;i++) {
       check(e!=INVALID,"Wrong InEdge list linking.");
-      check(n==G.head(e), "Wrong InEdge list linking.");
+      check(n==G.target(e), "Wrong InEdge list linking.");
       ++e;
     }
@@ -82,5 +82,5 @@
 
   ///\file
-  ///\todo Check head(), tail() as well;
+  ///\todo Check target(), source() as well;
 
   
Index: src/test/path_test.cc
===================================================================
--- src/test/path_test.cc	(revision 959)
+++ src/test/path_test.cc	(revision 986)
@@ -48,11 +48,11 @@
   P.clear();                      //void clear() {}
 
-  gn=P.head();                    //GraphNode/*It*/ head() const {return INVALID;}
-  gn=P.tail();                    //GraphNode/*It*/ tail() const {return INVALID;}
+  gn=P.target();                    //GraphNode/*It*/ target() const {return INVALID;}
+  gn=P.source();                    //GraphNode/*It*/ source() const {return INVALID;}
 
   ei=P.first(ei);                 //It& first(It &i) const { return i=It(*this); }
 
-  ni=P.head(ei);                  //NodeIt head(const EdgeIt& e) const {}
-  ni=P.tail(ei);                  //NodeIt tail(const EdgeIt& e) const {}
+  ni=P.target(ei);                  //NodeIt target(const EdgeIt& e) const {}
+  ni=P.source(ei);                  //NodeIt source(const EdgeIt& e) const {}
 
 
Index: src/test/preflow_test.cc
===================================================================
--- src/test/preflow_test.cc	(revision 959)
+++ src/test/preflow_test.cc	(revision 986)
@@ -68,5 +68,5 @@
   int c=0;
   for(SmartGraph::EdgeIt e(g); e!=INVALID; ++e) {
-    if (cut[g.tail(e)] && !cut[g.head(e)]) c+=cap[e];
+    if (cut[g.source(e)] && !cut[g.target(e)]) c+=cap[e];
   }
   return c;
Index: src/test/sym_graph_test.cc
===================================================================
--- src/test/sym_graph_test.cc	(revision 959)
+++ src/test/sym_graph_test.cc	(revision 986)
@@ -31,5 +31,5 @@
 This test makes consistency checks of list graph structures.
 
-G.addNode(), G.addEdge(), G.tail(), G.head()
+G.addNode(), G.addEdge(), G.source(), G.target()
 
 \todo Checks for empty graphs and isolated points.
Index: src/test/sym_graph_test.h
===================================================================
--- src/test/sym_graph_test.h	(revision 959)
+++ src/test/sym_graph_test.h	(revision 986)
@@ -74,6 +74,6 @@
 	SymEdge se;
 	se=INVALID;
-	n=G.tail(se);
-	n=G.head(se);
+	n=G.source(se);
+	n=G.target(se);
       }
       // id tests
@@ -175,5 +175,5 @@
 
   ///\file
-  ///\todo Check head(), tail() as well;
+  ///\todo Check target(), source() as well;
 
   
Index: src/test/test_tools.h
===================================================================
--- src/test/test_tools.h	(revision 978)
+++ src/test/test_tools.h	(revision 986)
@@ -106,5 +106,5 @@
 
   for(typename std::vector<Edge>::iterator p=ee.begin();p!=ee.end();p++)
-    G.addEdge(G.head(*p),G.tail(*p));
+    G.addEdge(G.target(*p),G.source(*p));
 }
 
Index: src/work/alpar/bfs-named-param.cc
===================================================================
--- src/work/alpar/bfs-named-param.cc	(revision 945)
+++ src/work/alpar/bfs-named-param.cc	(revision 986)
@@ -11,32 +11,37 @@
 struct _BFS_CUSTOM_VIS {};
 
-template<class GT,class VT,class DVT,class PNT,class PET,class PT >
-class _BFS 
+
+class _Bfs_Traits 
+{
+  typedef ListGraph Graph;
+}
+
+template<class T>
+class _Bfs 
 {
  public:
-  typedef GT Graph;
-  typedef VT Visited;
-  typedef PNT PredNode;
-  typedef PET PredEdge;
-  typedef PT Priority;
-  //  typedef QDT QueueData;
+  typedef typename T::Graph Graph;
+  typedef typename T::Reached Reached;
+  typedef typename T::PredNode PredNode;
+  typedef typename T::PredEdge PredEdge;
+  typedef typename T::Priority Priority;
+  
+  typedef typename T::DefaultReachedTag DefaultReachedTag;
   
   typedef typename Graph::Node Node;
   typedef typename Graph::OutEdgeIt OutEdgeIt;
 
-  typedef DVT DefaultVisitedTag;
-  
   const Graph &_graph;
 
   Node _source;
   
-  Visited *_visited;
+  Reached *_visited;
   PredNode _predNode;
   PredEdge _predEdge;
   Priority _priority;
 
-  _BFS(const Graph &g,
+  _Bfs(const Graph &g,
        Node s,
-       Visited *v,
+       Reached *v,
        PredNode &pn,
        PredEdge &pe,
@@ -46,5 +51,5 @@
 
   
-  int run(const _BFS_CUSTOM_VIS &) 
+  int run(const _Bfs_CUSTOM_VIS &) 
   {
     using namespace std;
@@ -64,5 +69,5 @@
       Node n=Q[Qt++];
       for(OutEdgeIt e(_graph,n);e!=INVALID;++e)
-	if(!(*_visited)[m=_graph.head(e)]) {
+	if(!(*_visited)[m=_graph.target(e)]) {
 	  Q[Qh++]=m;
 	  _visited->set(m,true);
@@ -76,23 +81,23 @@
   int run(const _BFS_DEFAULT_VIS &) 
   {
-    _visited= new Visited(_graph);
+    _visited= new Reached(_graph);
     int r = run(_BFS_CUSTOM_VIS());
     delete _visited;
     return r;
   }
-  int run() { return run(DefaultVisitedTag());}
-
-  template<class T> _BFS<Graph,T,_BFS_CUSTOM_VIS,PredNode,PredEdge,Priority>
+  int run() { return run(DefaultReachedTag());}
+
+  template<class T> _Bfs<Graph,T,_BFS_CUSTOM_VIS,PredNode,PredEdge,Priority>
   setVisitMap(T &t)
   {
-    return _BFS<Graph,T,_BFS_CUSTOM_VIS,PredNode,PredEdge,Priority>
+    return _Bfs<Graph,T,_BFS_CUSTOM_VIS,PredNode,PredEdge,Priority>
       (_graph,_source,&t,_predNode,_predEdge,_priority);
   }
 
   template<class T>
-  _BFS<Graph,Visited,DefaultVisitedTag,T,PredEdge,Priority>
+  _Bfs<Graph,Reached,DefaultReachedTag,T,PredEdge,Priority>
   setPredNodeMap(T &t)
   {
-    return _BFS<Graph,Visited,DefaultVisitedTag,T,PredEdge,Priority>
+    return _BFS<Graph,Reached,DefaultReachedTag,T,PredEdge,Priority>
       (_graph,_source,
        _visited,
@@ -101,8 +106,8 @@
 
   template<class T>
-  _BFS<Graph,Visited,DefaultVisitedTag,PredNode,T,Priority>
+  _BFS<Graph,Reached,DefaultReachedTag,PredNode,T,Priority>
   setPredEdgeMap(T &t)
   {
-    return _BFS<Graph,Visited,DefaultVisitedTag,PredNode,T,Priority>
+    return _BFS<Graph,Reached,DefaultReachedTag,PredNode,T,Priority>
       (_graph,_source,
        _visited,
@@ -110,8 +115,8 @@
   }
 
-  _BFS<Graph,Visited,DefaultVisitedTag,PredNode,PredEdge,Priority>
+  _Bfs<Graph,Reached,DefaultReachedTag,PredNode,PredEdge,Priority>
   setNothing()
   {
-    return _BFS<Graph,Visited,DefaultVisitedTag,PredNode,PredEdge,Priority>
+    return _Bfs<Graph,Reached,DefaultReachedTag,PredNode,PredEdge,Priority>
       (_graph,_source,
        _visited,
@@ -122,5 +127,5 @@
 
 template<class G>
-_BFS<G,
+_Bfs<G,
      typename G::template NodeMap<bool>,
      _BFS_DEFAULT_VIS,
@@ -132,5 +137,5 @@
   //  typename G::template NodeMap<bool> v(g);
 
-  return _BFS < G,
+  return _Bfs < G,
     typename G::template NodeMap<bool>,
     _BFS_DEFAULT_VIS,
@@ -147,9 +152,9 @@
 
 
-class MyVisitedMap : public SmartGraph::NodeMap<bool>
+class MyReachedMap : public SmartGraph::NodeMap<bool>
 {
   const SmartGraph &_G;
 public:
-  MyVisitedMap(const SmartGraph &G) : SmartGraph::NodeMap<bool>(G), _G(G) {}
+  MyReachedMap(const SmartGraph &G) : SmartGraph::NodeMap<bool>(G), _G(G) {}
   void set(SmartGraph::Node n,bool b)
   {
@@ -181,5 +186,5 @@
   SmartGraph::NodeMap<SmartGraph::Edge> em(G);
 
-  MyVisitedMap vm(G);
+  MyReachedMap vm(G);
 
 
Index: src/work/alpar/boolmap_iter.cc
===================================================================
--- src/work/alpar/boolmap_iter.cc	(revision 921)
+++ src/work/alpar/boolmap_iter.cc	(revision 986)
@@ -120,12 +120,12 @@
 
   for(EdgeIt e(G);G.valid(e);G.next(e))
-    std::cout << G.id(G.tail(e)) << "->" << G.id(G.head(e))
+    std::cout << G.id(G.source(e)) << "->" << G.id(G.target(e))
       << ": " << map[e] << '\n';
   std::cout << "True Edges:\n";
   for(BoolIterEdgeMap<Graph>::TrueIterator i(map);i;++i)
-    std::cout << G.id(G.tail(i)) << "->" << G.id(G.head(i)) << '\n';
+    std::cout << G.id(G.source(i)) << "->" << G.id(G.target(i)) << '\n';
   std::cout << "False Edges:\n";
   for(BoolIterEdgeMap<Graph>::FalseIterator i(map);i;++i)
-    std::cout << G.id(G.tail(i)) << "->" << G.id(G.head(i)) << '\n';
+    std::cout << G.id(G.source(i)) << "->" << G.id(G.target(i)) << '\n';
 }
 
Index: src/work/alpar/dijkstra.h
===================================================================
--- src/work/alpar/dijkstra.h	(revision 967)
+++ src/work/alpar/dijkstra.h	(revision 986)
@@ -394,5 +394,5 @@
 	
 	for(OutEdgeIt e(*G,v); e!=INVALID; ++e) {
-	  Node w=G->head(e); 
+	  Node w=G->target(e); 
 	  switch(heap.state(w)) {
 	  case Heap::PRE_HEAP:
Index: src/work/alpar/f_ed_ka.h
===================================================================
--- src/work/alpar/f_ed_ka.h	(revision 921)
+++ src/work/alpar/f_ed_ka.h	(revision 986)
@@ -85,15 +85,15 @@
       c.get(tree.get(t))-f.get(tree.get(t)) : f.get(tree.get(t));
     //FIXME: I would need 'G.opposite(e,n)'
-    gn = visited.get(t)==1 ? G.tail(tree.get(t)) : G.head(tree.get(t));
+    gn = visited.get(t)==1 ? G.source(tree.get(t)) : G.target(tree.get(t));
     while(gn!=s) if(visited.get(gn)==1)
       {
 	//FIXME: nonstandard gcc extension!
 	aug_val <?= c.get(tree.get(gn))-f.get(tree.get(gn));
-	gn=G.tail(tree.get(gn));
+	gn=G.source(tree.get(gn));
       }
     else {
       //FIXME: nonstandard gcc extension!
       aug_val <?= f.get(tree.get(gn));
-      gn=G.head(tree.get(gn));
+      gn=G.target(tree.get(gn));
     }
 	
@@ -103,9 +103,9 @@
       {
 	f.set(tree.get(gn),f.get(tree.get(gn))+aug_val);
-	gn=G.tail(tree.get(gn));
+	gn=G.source(tree.get(gn));
       }
     else {
       f.set(tree.get(gn),f.get(tree.get(gn))-aug_val);
-      gn=G.head(tree.get(gn));
+      gn=G.target(tree.get(gn));
     }
 
Index: src/work/alpar/f_ed_ka_demo.cc
===================================================================
--- src/work/alpar/f_ed_ka_demo.cc	(revision 921)
+++ src/work/alpar/f_ed_ka_demo.cc	(revision 986)
@@ -42,5 +42,5 @@
   //std::cout << "maximum flow: "<< std::endl;
   //for(EachEdgeIt e=G.first<EachEdgeIt>(); e.valid(); ++e) { 
-  //  std::cout<<"("<<G.tail(e)<< "-"<<flow.get(e)<<"->"<<G.head(e)<<") ";
+  //  std::cout<<"("<<G.source(e)<< "-"<<flow.get(e)<<"->"<<G.target(e)<<") ";
   //}
   //std::cout<<std::endl;
Index: src/work/alpar/graph.h
===================================================================
--- src/work/alpar/graph.h	(revision 253)
+++ src/work/alpar/graph.h	(revision 986)
@@ -107,8 +107,8 @@
       // Lehet, hogy ez a ketto nem kell!!!
       
-      NodeIterator tail() const {NodeIterator i;i.G=G;i.n=e->From();return i;}
-      NodeIterator head() const {NodeIterator i;i.G=G;i.n=e->To();return i;}
+      NodeIterator source() const {NodeIterator i;i.G=G;i.n=e->From();return i;}
+      NodeIterator target() const {NodeIterator i;i.G=G;i.n=e->To();return i;}
       NodeIterator opposite(const NodeIterator &n) const
-      {return n==tail()?head():tail();}
+      {return n==source()?target():source();}
       
       bool valid() {return e;}
@@ -191,6 +191,6 @@
       {OutEdgeIterator tmp(*this); goNext(); return tmp;}
       
-      NodeIterator aNode() const {return tail();}
-      NodeIterator bNode() const {return head();}
+      NodeIterator aNode() const {return source();}
+      NodeIterator bNode() const {return target();}
       
       operator const InEdgeIterator ()
@@ -219,5 +219,5 @@
       
       NodeIterator aNode() const {return n;}
-      NodeIterator bNode() const {return n.n==tail().n?head():tail();}
+      NodeIterator bNode() const {return n.n==source().n?target():source();}
       
       operator const InEdgeIterator ()
@@ -255,5 +255,5 @@
       
       NodeIterator aNode() const {return n;}
-      NodeIterator bNode() const {return n.n==tail().n?head():tail();}
+      NodeIterator bNode() const {return n.n==source().n?target():source();}
       
       operator const EdgeIterator ()
@@ -464,6 +464,6 @@
     {
       return n?
-	reversed[n-1]?path[n-1].tail():path[n-1].head():
-	reversed[0]?path[0].head():path[0].tail();
+	reversed[n-1]?path[n-1].source():path[n-1].target():
+	reversed[0]?path[0].target():path[0].source();
     }
     void setRevert(int n,bool r=true) {reversed[n]=r;}
@@ -471,5 +471,5 @@
     {
       path[n]=i;
-      reversed[n] = i.head()==i.aNode();
+      reversed[n] = i.target()==i.aNode();
     }
     void setEdge(int n,EdgeIterator i,bool r)
@@ -479,6 +479,6 @@
     }
 
-    NodeIterator tail() { return getNode(0); }
-    NodeIterator head() { return getNode(getLength()); }
+    NodeIterator source() { return getNode(0); }
+    NodeIterator target() { return getNode(getLength()); }
   };
   
Index: src/work/alpar/gwrapper.h
===================================================================
--- src/work/alpar/gwrapper.h	(revision 921)
+++ src/work/alpar/gwrapper.h	(revision 986)
@@ -28,8 +28,8 @@
   template<typename I> I &goNext(I &i); { return graph->goNext(i); }
 
-  NodeIt head(const EdgeIt &e);
-  { return graph->head(e); }
-  NodeIt tail(const EdgeIt &e);
-  { return graph->tail(e); }
+  NodeIt target(const EdgeIt &e);
+  { return graph->target(e); }
+  NodeIt source(const EdgeIt &e);
+  { return graph->source(e); }
   
   template<typename I> NodeIt aNode(const I e);
@@ -84,8 +84,8 @@
   template<typename I> I &goNext(I &i); { return graph->goNext(i); }
 
-  NodeIt head(const EdgeIt &e);
-  { return graph->tail(e); }
-  NodeIt tail(const EdgeIt &e);
-  { return graph->head(e); }
+  NodeIt target(const EdgeIt &e);
+  { return graph->source(e); }
+  NodeIt source(const EdgeIt &e);
+  { return graph->target(e); }
   
   template<typename I> NodeIt aNode(const I e);
@@ -138,8 +138,8 @@
 //   template<typename I> I &goNext(I &i); { return graph->goNext(i); }
 
-  NodeIt head(const EdgeIt &e);
-  { return G::tail(e); }
-  NodeIt tail(const EdgeIt &e);
-  { return G::head(e); }
+  NodeIt target(const EdgeIt &e);
+  { return G::source(e); }
+  NodeIt source(const EdgeIt &e);
+  { return G::target(e); }
   
 //   template<typename I> NodeIt aNode(const I e);
@@ -195,8 +195,8 @@
   template<typename I> I &goNext(I &i); { return graph->goNext(i); }
 
-  NodeIt head(const EdgeIt &e);
-  { return graph->head(e); }
-  NodeIt tail(const EdgeIt &e);
-  { return graph->tail(e); }
+  NodeIt target(const EdgeIt &e);
+  { return graph->target(e); }
+  NodeIt source(const EdgeIt &e);
+  { return graph->source(e); }
   
   template<typename I> NodeIt aNode(const I e);
@@ -344,8 +344,8 @@
   template<typename I> I next(const I i); { return graph->goNext(i); }
 
-  NodeIt head(const EdgeIt &e);
-  { return graph->head(e); }
-  NodeIt tail(const EdgeIt &e);
-  { return graph->tail(e); }
+  NodeIt target(const EdgeIt &e);
+  { return graph->target(e); }
+  NodeIt source(const EdgeIt &e);
+  { return graph->source(e); }
   
   template<typename I> NodeIt aNode(const I e);
Index: src/work/alpar/list_graph_demo.cc
===================================================================
--- src/work/alpar/list_graph_demo.cc	(revision 959)
+++ src/work/alpar/list_graph_demo.cc	(revision 986)
@@ -112,8 +112,8 @@
     for(EdgeIt e(G);G.valid(e);G.next(e)) em[e]=G.id(e);
     for(EdgeIt e(G);G.valid(e);G.next(e))
-      if(G.tail(e)<G.head(e)) sm[e]=G.id(e);
+      if(G.source(e)<G.target(e)) sm[e]=G.id(e);
     
     for(EdgeIt e(G);G.valid(e);G.next(e))
-      std::cout << G.id(G.tail(e)) << "->" << G.id(G.head(e))
+      std::cout << G.id(G.source(e)) << "->" << G.id(G.target(e))
 		<< ": id=" << G.id(e) << " oppid=" << G.id(G.opposite(e))
 		<< " em=" << em[e]
Index: src/work/alpar/rw_nonref_map.cc
===================================================================
--- src/work/alpar/rw_nonref_map.cc	(revision 921)
+++ src/work/alpar/rw_nonref_map.cc	(revision 986)
@@ -24,6 +24,6 @@
     {
       ValueType tmp;
-      std::cout << G.id(G.tail(e)) << "->"
-		<< G.id(G.head(e)) << ": ";
+      std::cout << G.id(G.source(e)) << "->"
+		<< G.id(G.target(e)) << ": ";
       std::cin  >> tmp;
       return tmp;
@@ -31,6 +31,6 @@
     ValueType operator = (ValueType v) const
     {
-      std::cout << G.id(G.tail(e)) << "->"
-		<< G.id(G.head(e)) << ": " << v << '\n';
+      std::cout << G.id(G.source(e)) << "->"
+		<< G.id(G.target(e)) << ": " << v << '\n';
       return v;
     }
Index: src/work/alpar/smart_graph_demo.cc
===================================================================
--- src/work/alpar/smart_graph_demo.cc	(revision 921)
+++ src/work/alpar/smart_graph_demo.cc	(revision 986)
@@ -112,8 +112,8 @@
     for(EdgeIt e(G);G.valid(e);G.next(e)) em[e]=G.id(e);
     for(EdgeIt e(G);G.valid(e);G.next(e))
-      if(G.tail(e)<G.head(e)) sm[e]=G.id(e);
+      if(G.source(e)<G.target(e)) sm[e]=G.id(e);
     
     for(EdgeIt e(G);G.valid(e);G.next(e))
-      std::cout << G.id(G.tail(e)) << "->" << G.id(G.head(e))
+      std::cout << G.id(G.source(e)) << "->" << G.id(G.target(e))
 		<< ": id=" << G.id(e) << " oppid=" << G.id(G.opposite(e))
 		<< " em=" << em[e]
Index: src/work/athos/bfs_test.cc
===================================================================
--- src/work/athos/bfs_test.cc	(revision 921)
+++ src/work/athos/bfs_test.cc	(revision 986)
@@ -42,5 +42,5 @@
       OutEdgeIt e;
       for(g.first(e,v); g.valid(e); g.next(e)) {
-	Node w=g.head(e);
+	Node w=g.target(e);
 	if (!reached[w]) {
 	  bfs_queue.push(w);
Index: src/work/athos/dijkstra_demo.cc
===================================================================
--- src/work/athos/dijkstra_demo.cc	(revision 921)
+++ src/work/athos/dijkstra_demo.cc	(revision 986)
@@ -130,8 +130,8 @@
     std::cout << "out edges: ";
     for(out_edge_iterator j=flow_test.first_out_edge(i); j.valid(); ++j) 
-      std::cout << node_name.get(flow_test.tail(j)) << "-"<< cap.get(j) << "->" << node_name.get(flow_test.head(j)) << " ";
+      std::cout << node_name.get(flow_test.source(j)) << "-"<< cap.get(j) << "->" << node_name.get(flow_test.target(j)) << " ";
     std::cout << "in edges: ";
     for(in_edge_iterator j=flow_test.first_in_edge(i); j.valid(); ++j) 
-      std::cout << node_name.get(flow_test.tail(j)) << "-"<< cap.get(j) << "->" << node_name.get(flow_test.head(j)) << " ";
+      std::cout << node_name.get(flow_test.source(j)) << "-"<< cap.get(j) << "->" << node_name.get(flow_test.target(j)) << " ";
     std::cout << std::endl;
   }
